import java.util.Iterator;
import java.util.Vector;


public class YicesObject {
	public Vector<String> define_list;
	public Vector<String> conjunction_list;
	public Vector<String> mc_list;	
	public Vector<Infos> info_list;
	public ActionsAtRound actions_at_round;
	public GoalsAtPriority goals_at_prio;
	
	public YicesObject(){
		this.define_list=new Vector<String>();
		this.conjunction_list=new Vector<String>();
		this.mc_list=new Vector<String>();
		this.actions_at_round=new ActionsAtRound();
		this.goals_at_prio=new GoalsAtPriority();
		this.info_list=new Vector<Infos>();
	}
	
	public YicesObject(YicesObject yo){
		this.define_list=new Vector<String>();
		this.define_list.addAll(yo.define_list);
		this.conjunction_list=new Vector<String>();
		this.conjunction_list.addAll(yo.conjunction_list);
		this.mc_list=new Vector<String>();
		this.mc_list.addAll(yo.mc_list);
		this.actions_at_round=new ActionsAtRound(yo.actions_at_round);
		this.goals_at_prio=new GoalsAtPriority(yo.goals_at_prio);
		this.info_list=new Vector<Infos>();
		this.info_list.addAll(yo.info_list);
		//TODO this.printYicesObject(yo);
	}
	
	public void becomeCrossProductActionsObject (YicesObject yo)throws Exception{
		this.define_list=new Vector<String>();
		this.define_list.addAll(yo.define_list);
		this.conjunction_list=new Vector<String>();
		this.conjunction_list.addAll(yo.conjunction_list);
		this.mc_list=new Vector<String>();
		this.mc_list.addAll(yo.mc_list);
		this.info_list=new Vector<Infos>();
		this.info_list.addAll(yo.info_list);
		Iterator<Integer> it_rounds=yo.actions_at_round.keySet().iterator();
		Vector<Actions> acts;
		Vector<Actions> cross_acts;
		this.actions_at_round=new ActionsAtRound();
		Integer round;
		System.out.println("Actions at round "+yo.actions_at_round);
		while(it_rounds.hasNext()){
			round=it_rounds.next();
			acts=yo.actions_at_round.get(round);
			cross_acts=crossProductOf(acts);
			this.actions_at_round.put(round, cross_acts);
		}
		this.goals_at_prio=new GoalsAtPriority(yo.goals_at_prio);
	}
	
	public Vector<Actions> crossProductOf(Vector<Actions> acts_v)throws Exception{
		Actions acts;
		if(acts_v.size()<1){
			throw new Exception("Empty action list.");
		}
		if(acts_v.get(0).size()<1){
			throw new Exception("Empty actions.");

		}
		Actions new_acts=new Actions(acts_v.get(0));
		Actions actions=new Actions();
		String action;
		for(int iii=1; iii<acts_v.size();iii++){
			acts=acts_v.get(iii);
			for(int jjj=0; jjj<new_acts.size(); jjj++){
				for(int kkk=0; kkk<acts.size(); kkk++){
					action="(and "+new_acts.get(jjj)+" "+acts.get(kkk)+")";
					actions.add(action);
				}
			}			
			new_acts=new Actions(actions);
			actions=new Actions();
		}
		Vector<Actions> new_acts_v=new Vector<Actions>();
		new_acts_v.add(new_acts);
		return new_acts_v;
	}
	public void removeAction(String action, Integer round)throws Exception{
		if(this.actions_at_round.get(round).size()!=1){throw new Exception("Unexpected size of actions vector. Expected cross vectorisation and hence size 1.");}
		this.actions_at_round.get(round).get(0).remove(action);
		return;
	}
	
	public void setAction(String action, Integer round)throws Exception{
		if(this.actions_at_round.get(round).size()!=1){throw new Exception("Unexpected size of actions vector. Expected cross vectorisation and hence size 1.");}
		Vector<Actions> actions=new Vector<Actions>();
		Actions acts=new Actions();
		acts.add(action);
		actions.add(acts);
		this.actions_at_round.put(round,actions);
		return;
	}
	public void setGoals(Vector<String> goals)throws Exception{
		this.goals_at_prio=new GoalsAtPriority();
		this.goals_at_prio.put(new Integer(1),goals);
		return;
	}
	public void printYicesObject(){
		System.out.println("def "+this.define_list);
		System.out.println("con "+this.conjunction_list);
		System.out.println("mc  "+this.mc_list);
		System.out.println("act"+this.actions_at_round);
		System.out.println("goa"+this.goals_at_prio);
		System.out.println("inf"+this.info_list);
	}
	
	public void printlYicesObject(YicesObject yo){
		System.out.println("def  "+this.define_list+" || "+yo.define_list);
		System.out.println("con  "+this.conjunction_list+" || "+yo.conjunction_list);
		System.out.println("mc   "+this.mc_list+" || "+yo.mc_list);
		System.out.println("act  "+this.actions_at_round+" || "+yo.actions_at_round);
		System.out.println("goal "+this.goals_at_prio+" || "+yo.goals_at_prio);
		System.out.println("inf  "+this.info_list+"  ||  "+yo.info_list);	
	}
}
