import java.io.*;
import java.util.Iterator;
import java.util.Vector;
import java.util.concurrent.TimeUnit;


public class YicesWriter {
	private int assertion_id=0;
	BufferedWriter bw;
	Iterator<Integer> it_int;
	Iterator<Actions> it_act;
	Iterator<String> it;
	YicesObject yo;
	public IdManager im;
	
	public static void main(String args[]) {
		try{
			YicesWriter writer=new YicesWriter();
			YicesModelFileParser yp=new YicesModelFileParser();
			String data_dir="/home/astridr/programming/java/YicesTools/data/";
			yp.parse(data_dir+"conflict3.ys.txt");
			writer.write(data_dir+"conflict.ys",yp.yo);	
		}catch(Exception exc){
			exc.printStackTrace();
		}
	}
	
	public YicesWriter(){
		this.im=new IdManager();
	}
	public YicesWriter(IdManager im_in){
		this.im=im_in;
	}
	
	public void write(String file, YicesObject yo_in)throws Exception{
		bw=new BufferedWriter(new FileWriter(file));
		this.yo=yo_in;
		this.writeDefine();
		this.writeStrategy();
		this.writeGoal();
		this.writeMc();
		bw.flush();
		bw.close();
	}
	
	public void writeNegGoal(String file, YicesObject yo_in)throws Exception{
		bw=new BufferedWriter(new FileWriter(file));
		this.yo=yo_in;
		this.writeDefine();
		this.writeStrategy();
		this.writeNegGoal();
		this.writeMc();
		bw.flush();
		bw.close();
	}
	
	protected void writeMc()throws Exception{
		it=yo.mc_list.iterator();
		while(it.hasNext()){
			bw.write(it.next());
			bw.write("\n");
		}
	}
	protected void writeStrategy()throws Exception{
		bw.write(";; own strategie \n");
		it_int=yo.actions_at_round.keySet().iterator();
		
		Vector<Actions> actions;
		String act;
		StringBuffer line_bf=new StringBuffer();
		while(it_int.hasNext()){
			actions=yo.actions_at_round.get(it_int.next());
			it_act=actions.iterator();
			while(it_act.hasNext()){
				line_bf.append("(assert ");
				it=it_act.next().iterator();
				act="";
				while(it.hasNext()){
					if(act.length()==0){
						act=it.next();						
					}else{
						act="(or "+act+" "+it.next()+")";
					}
				}
				line_bf.append(act);
				line_bf.append(" T");
				line_bf.append(this.im.getTransId(act));
				line_bf.append(")\n");					
				bw.write(line_bf.toString());
				line_bf=new StringBuffer();
			}
		}
	}
	protected void writeDefine()throws Exception{
		it=yo.define_list.iterator();
		while(it.hasNext()){
			bw.write(it.next());
			bw.write("\n");
		}
		it=yo.conjunction_list.iterator();
		String line;
		StringBuffer line_bf=new StringBuffer();
		while(it.hasNext()){
			line=it.next();
			line_bf.append("(assert ");
			line_bf.append(line);
			line_bf.append(" C");
			line_bf.append(this.im.getConjunctionId(line));
			line_bf.append(")");
			//System.out.println("A "+line_bf.toString());
			bw.write(line_bf.toString());
			bw.write("\n");
			line_bf=new StringBuffer();
		}
	}
	protected void writeGoal()throws Exception{
		//iterator over all goals
		bw.write(";; goals \n");
		it_int=yo.goals_at_prio.keySet().iterator();
		Vector<String> goals;
		StringBuffer line_bf=new StringBuffer();
		String goal;
		while(it_int.hasNext()){
			goals=yo.goals_at_prio.get(it_int.next());
			it=goals.iterator();
			while(it.hasNext()){
				goal=it.next();
				line_bf.append("(assert ");
				line_bf.append(goal);
				line_bf.append(" G");
				line_bf.append(this.im.getGoalId(goal));
				line_bf.append(")\n");
				bw.write(line_bf.toString());
				line_bf=new StringBuffer();
			}
		}
	}
	
	protected void writeNegGoal()throws Exception{
		//iterator over all goals
		bw.write(";; goals \n");
		it_int=yo.goals_at_prio.keySet().iterator();
		Vector<String> goals;
		StringBuffer line_bf=new StringBuffer();
		line_bf.append("(assert (not ");
		String goal="";
		while(it_int.hasNext()){
			goals=yo.goals_at_prio.get(it_int.next());
			it=goals.iterator();
			while(it.hasNext()){
					if(goal.length()==0){
						goal=it.next();						
					}else{
						goal="(and "+goal+" "+it.next()+")";
					}
			}
		}
		line_bf.append(goal);
		line_bf.append(") G");
		line_bf.append(this.im.getGoalId(goal));
		line_bf.append(")\n");
		bw.write(line_bf.toString());
	}
}
